rem --------------------------------------------------------------
rem  Konverter Postscript Ausdruck zu SMTP Mail
rem  
rem  Frank Carius, info@netatwork.de, 31. Mrz 2004
rem
rem Diese Job wird durch "REDMON" aufgerufen, welcher als Postmonitor
rem die Ausgaben eines Postscript Treibers umleitet.
rem Anhand des Job Owners wird die PS Datei in PDF konvertiert und per 
rem SMTP an den Owner zurckgesendet
rem Version 1.0  erste Version
rem Version 1.1  Korrekturen: fehlende Anfuerhungszeichen etc
rem Version 1.2  Verbessertes Debugging
rem Version 1.3  Verbessertes Debugging bei BLAT aktiviert mehr Doku
rem              Untersttzung von GS8.14 Kennwortschutz
rem Version 1.4  Sonderzeichenbehandlung.  danke an Andreas Huch
rem Version 1.5  Umstellung auf REDFILE statt Redrum da Probleme mit NT4/WIN95
rem                 Neue Variable PDF2SMTPTEMP
rem                 Kommandoparameter nicht mehr genutzt.
rem Version 1.6  Anpassung der Encryption fr GhostScript 8.51
rem 			 Anpassung der TEMP-Pfade fr Windows 20003
rem --------------------------------------------------------------


rem --------------------- Definition der Parameter. muessen angepasst werden !! ---------------

rem ----------------- Pfad fr temporre Dateien
rem set pdf2smtptemp=%TEMP%
set pdf2smtptemp=C:\Programme\gs\temp
rem     Achtung: Das Verzeichnis muss existieren, 
rem              SYSTEM bentigt NDERN-Rechte, 
rem              kein \ am Ende anhaengen
	
rem ----------------- Pfad fr die Protokolldatei
set pdf2smtplog="c:\Programme\gs\redmon\pdf2smtp.log"

rem ----------------- Pfad zu Ghostscript
set pdf2smtpgs="c:\programme\gs\gs8.51\bin\gswin32c.exe"

rem ----------------- Pfad zu BLAT
set pdf2smtpblat="c:\Programme\gs\redmon\blat.exe"

rem ----------------- SMTP-Domne fuer die Mails
set pdf2smtpmaildomain=firma.de

rem-----------------  Mailserver zum Versand der Nachrichten. IP-Adresse oder DNS-Name
set pdf2smtpmailserver="mail.firma.de"

rem-----------------  Einstellungen fr den PDF Schutz
ALT
rem -3904 = nur Ansehen
rem -1856 = Ansehen und Drucken
rem -4 = enable all
rem details http://casper.ghostscript.com/~ghostgum/pdftips.htm

set pdfprotect=-1856
set pdfpassword=geheim

echo PDF2SMTP %DATE% %TIME% PDF2SMTP Version 1.5 gestartet------------------- >>%pdf2smtplog%

rem  -----------------  Behandlung der Sonderzeichen
echo PDF2SMTP %DATE% %TIME% Behandlung der Sonderzeichen ------------------- >>%pdf2smtplog%
SET REDMON_DOCNAME=%REDMON_DOCNAME:\=_%
SET REDMON_DOCNAME=%REDMON_DOCNAME:/=_%
SET REDMON_DOCNAME=%REDMON_DOCNAME::=_%
SET REDMON_DOCNAME=%REDMON_DOCNAME:?=_%
SET REDMON_DOCNAME=%REDMON_DOCNAME:<=_%
SET REDMON_DOCNAME=%REDMON_DOCNAME:>=_%
SET REDMON_DOCNAME=%REDMON_DOCNAME:|=_%
SET REDMON_DOCNAME=%REDMON_DOCNAME:"=_%
rem Eine Behandlung von "*" als Sonderzeichen ist mir nicht bekannt

rem  -----------------  Ausgabe der Daten in die Protokolldatei zur Fehlersuche
echo PDF2SMTP %DATE% %TIME% Umgebungsvariablen -------------------------------- >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% REDMON_PORT      = %REDMON_PORT%                    >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% REDMON_JOB       = %REDMON_JOB%                     >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% REDMON_PRINTER   = %REDMON_PRINTER%                 >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% REDMON_MACHINE   = %REDMON_MACHINE%                 >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% REDMON_USER      = %REDMON_USER%                    >>%pdf2smtplog% 
echo PDF2SMTP %DATE% %TIME% REDMON_DOCNAME   = %REDMON_DOCNAME%                 >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% REDMON_FILENAME  = %REDMON_FILENAME%                >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% REDMON_SESSIONID = %REDMON_SESSIONID%               >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% Kommandozeile    = %1                               >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% PDF2SMTPTEMP-Pfad= %PDF2SMTPTEMP%                   >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% GS-Pfad          = %pdf2smtpgs%                     >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% Blat-Pfad        = %pdf2smtpblat%                   >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% Mailserver       = %pdf2smtpmailserver%             >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% SMTP-Domain      = %pdf2smtpmaildomain%             >>%pdf2smtplog%

rem ----------------- temporaere Dateipfade festlegen.
set BODYFILE="%PDF2SMTPTEMP%\%REDMON_USER%-%REDMON_DOCNAME%-%REDMON_JOB%.TXT"
set PDFFILE="%PDF2SMTPTEMP%\%REDMON_USER%-%REDMON_DOCNAME%-%REDMON_JOB%.PDF"
set PSFILE="%PDF2SMTPTEMP%\job-%REDMON_JOB%.ps"

rem ----------------- Ausgabe dieser temporaeren Dateipfade in die Protokolldatei
echo PDF2SMTP %DATE% %TIME% BODYFILE         = %BODYFILE%                       >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% PDFFILE          = %PDFFILE%                        >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% PSFILE           = %PSFILE%                         >>%pdf2smtplog%

rem -----------------  Druckausgabe von STDOUT abholen
echo PDF2SMTP %DATE% %TIME% Postscript von STDOUT abholen >>%pdf2smtplog%
c:\programme\gs\redmon\redfile.exe %PSFILE%

rem -----------------  Ghostscript Konvertierung
echo PDF2SMTP %DATE% %TIME% GS Konvertierung startet Input : %PSFILE%    >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% GS Konvertierung startet Output: %PDFFILE%   >>%pdf2smtplog%
start "PDF2SMTP GSKonvert" /WAIT %pdf2smtpgs% -dNOPAUSE -dBATCH -dEncryptionR#3 -dKeyLength#128 -sDEVICE=pdfwrite -dPDFSETTINGS=/default -dPermissions#%pdfprotect% -sOwnerPassword=%pdfpassword% -dCompatibilityLevel=1.4 -sOutputFile=%PDFFILE% %PSFILE%
echo PDF2SMTP %DATE% %TIME% GS Konvertierung beendet >>%pdf2smtplog%

rem ----------------- Fehlerbehandlung 
if exist %PDFFILE% goto sendpdf
echo PDF2SMTP %DATE% %TIME% Fehler bei der Konvertierung !!   >>%pdf2smtplog%
copy %PSFILE% *.err
echo PDF2SMTP %DATE% %TIME% PostscriptInput gesichert als %PSFILE%.err  >>%pdf2smtplog%

:sendpdf
rem goto skipsmtp
rem -----------------  Versand der Mail an den Benutzer
echo PDF2SMTP %DATE% %TIME% Sende Anlage per Mail                  >>%pdf2smtplog%
echo PDF2SMTP %DATE% %TIME% Empfaenger: %REDMON_USER%@%pdf2smtpmaildomain% >>%pdf2smtplog%

rem -----------------  Erzeugen des BODY
echo PDF2SMTP %DATE% %TIME% Erzeuge Mailbody                       >>%pdf2smtplog%
echo Ihr Konvertierungsauftrag wurde ausgefhrt           > %BODYFILE%
if exist %PDFFILE%     echo Sie finden Die PDF-Datei als Anlage an diese Mail    >>%BODYFILE%
if not exist %PDFFILE% echo !!! FEHLER bei der Konvertierung !!! >>%BODYFILE%
echo ---------------------------------------------------  >>%BODYFILE%
echo Ausdruck erzeugt von: %REDMON_USER%                  >>%BODYFILE%
echo Computer            : %REDMON_MACHINE%               >>%BODYFILE%
echo Drucker             : %REDMON_PRINTER%               >>%BODYFILE%
echo Dokumentname        : %REDMON_DOCNAME%               >>%BODYFILE%
echo Jobnummer           : %REDMON_JOB%                   >>%BODYFILE%
echo ---------------------------------------------------  >>%BODYFILE%
echo Erstellt von PDF2SMTP Version 1.5 am %DATE% %TIME%   >>%BODYFILE%

echo PDF2SMTP %DATE% %TIME% Sende SMTP-Mail >>%pdf2smtplog%

if exist %PDFFILE% start "PDF2SMTP Blat" /Wait %pdf2smtpblat%  %BODYFILE% -server %pdf2smtpmailserver% -f "pdf2smtp@%pdf2smtpmaildomain%" -t "%REDMON_USER%@%pdf2smtpmaildomain%" -s "%REDMON_DOCNAME%" -attach %PDFFILE% 
if not exist %PDFFILE% start "PDF2SMTP Blat" /Wait %pdf2smtpblat%  %BODYFILE% -server %pdf2smtpmailserver% -f "pdf2smtp@%pdf2smtpmaildomain%" -t "%REDMON_USER%@%pdf2smtpmaildomain%" -s "PDF2SMTP Fehler mit %REDMON_DOCNAME%"
:skipsmtp

rem Archivfunktion. Kopieren Sie alle erzeugten PDFs einfach in ein Verzeichnis
rem Ich nutze diese Funktion auf dem Notebook, wenn ich keinen Mailserver zur Verfgung habe
rem copy %PDFFILE% c:\

echo PDF2SMTP %DATE% %TIME% Cleanup                                    >>%pdf2smtplog%
del %BODYFILE%
del %PDFFILE%
del %PSFILE%

echo PDF2SMTP %DATE% %TIME% Beendet -------------------------------- >>%pdf2smtplog%
